"use strict";
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __param = (this && this.__param) || function (paramIndex, decorator) {
    return function (target, key) { decorator(target, key, paramIndex); }
};
Object.defineProperty(exports, "__esModule", { value: true });
// Angular
var wjcGridSheet = require("wijmo/wijmo.grid.sheet");
var wjcGrid = require("wijmo/wijmo.grid");
var wjcCore = require("wijmo/wijmo");
var core_1 = require("@angular/core");
var data_service_1 = require("./data.service");
require("rxjs/add/operator/finally");
var wjcGridXlsx = require("wijmo/wijmo.grid.xlsx");
'use strict';
// The Explorer application root component.
var AppComponent = /** @class */ (function () {
    function AppComponent(dataSvc) {
        var _this = this;
        this.gridHeight = 50;
        this.dataSvc = dataSvc;
        dataSvc.getData(10)
            .finally(function () { return console.log("Finally"); })
            .subscribe(function (d) {
            return _this.data = d;
        });
    }
    // flexSheetInit(flexSheetIntro: wjcGridSheet.FlexSheet) {
    //     var self = this;
    //     this.dataSource = new wjcCore.CollectionView(this.data);
    //     if (flexSheetIntro) {
    //         flexSheetIntro.deferUpdate(() => {
    //             flexSheetIntro.selectedSheetIndex = 0;
    //             flexSheetIntro.selectedSheet.itemsSource = this.dataSource;
    //             self._initDataMapForBindingSheet(flexSheetIntro);
    //         });
    //     }
    // }
    AppComponent.prototype.flexSheetInit = function (flexSheetIntro) {
        var _this = this;
        var self = this;
        flexSheetIntro.deferUpdate(function () {
            _this.dataSource = new wjcCore.CollectionView(_this.data);
            _this.dataSource.trackChanges = true;
            var grid = new wjcGrid.FlexGrid(document.createElement('div'), {
                itemsSource: _this.dataSource,
                columns: [
                    { header: 'Id', binding: 'id', isReadOnly: false, width: 90, visible: true },
                    {
                        header: 'Country Id', binding: 'countryId', width: 100,
                        visible: true, align: 'right', dropDownCssClass: 'data-map-font'
                    },
                    {
                        header: 'Product Id', binding: 'productId', width: 65, isReadOnly: true,
                        visible: true, dataType: 'Number', align: 'right'
                    },
                    { header: 'Date', binding: 'date', isReadOnly: true, width: 65, visible: true, align: 'right' },
                    {
                        header: 'Amount', binding: 'amount', width: 30, isReadOnly: true,
                        visible: true, dataType: 'Boolean'
                    },
                    {
                        header: 'Active', binding: 'active', width: 65, isReadOnly: true,
                        visible: true
                    }
                ]
            });
            flexSheetIntro.addBoundSheet('Assessment', _this.dataSource, 0, grid);
            // flexSheetIntro.isTabHolderVisible = false;
            // flexSheetIntro.headersVisibility = wjcGrid.HeadersVisibility.None;
            // flexSheetIntro.selectionMode = wjcGrid.SelectionMode.CellRange;
            // flexSheetIntro.allowDragging = wjcGrid.AllowDragging.None;
            // flexSheetIntro.allowResizing = wjcGrid.AllowResizing.None;
            // this.flexSheetIntro.allowDelete = true;
            // var current = this.dataSource.currentItem ? JSON.stringify(this.dataSource.currentItem) : null;
            // this.dataSource.currentChanged.addHandler(function (s, e) {
            //     current = s.currentItem ? JSON.stringify(s.currentItem) : null;
            //     console.log("currentChanged: " + current);
            //   });
            // let self = this;
            // this.dataSource.itemsEdited.collectionChanged.addHandler(function (s, e) {
            //     console.log("collectionChanged: "+ self.dataSource.itemsEdited);
            // });
            self._initDataMapForBindingSheet(self.flexSheetIntro);
            // let column = self.flexSheetIntro.columns.getColumn('countryId');
            // if (column) {
            //     let columnGrid = column.grid;
            //     columnGrid.formatItem.addHandler((s, e:wjcGrid.FormatItemEventArgs)=> {
            //         var editRange = grid.editRange,
            //             column = e.panel.columns[e.col];
            //         e.cell.innerHTML = "";
            //         // add custom editor
            //         var editorRoot = document.createElement('div');
            //         var input;
            //         if (column.dataType === wjcCore.DataType.String) {
            //             input = new wjInput.ComboBox(editorRoot);
            //             input.itemsSource = this.dataSvc.countries;   
            //             input.displayMemberPath = "country";
            //             input.selectedValuePath = "id";               
            //             input.headerPath = "value";
            //         }               
            //         e.cell.appendChild(editorRoot);                
            //     });
            // }
        });
    };
    AppComponent.prototype.ExportExcel = function () {
        wjcGridXlsx.FlexGridXlsxConverter.save(this.flexSheetIntro, { includeColumnHeaders: true, includeCellStyles: true }, "FlexGrid.xlsx");
    };
    AppComponent.prototype.onRowEditEnded = function (e) {
        console.log("onRowEditEnded");
    };
    AppComponent.prototype.rowEditStarted = function (e) {
        console.log("rowEditStarted");
    };
    AppComponent.prototype.selectionChanged = function (e) {
        // console.log("selectionChanged");
    };
    AppComponent.prototype.loadedRows = function (s, e) {
        var height = 0;
        for (var i = 0; i < s.rows.length; i++) {
            height += s.rows[i].renderHeight;
        }
        // add tabholder height
        height += 20;
        s.hostElement.style.height = height + 'px';
    };
    AppComponent.prototype.cellEditEnding = function (event) {
        console.log("cellEditEnding");
        // this.flexSheetIntro.scrollIntoView(80,-1);
        // let rc = this.flexSheetIntro.getCellBoundingRect(100, 0, true);
        // this.flexSheetIntro.scrollPosition = new wjcCore.Point(this.flexSheetIntro.scrollPosition.x, -rc.top);
        this.flag = true;
    };
    AppComponent.prototype.updatedView = function (e) {
        console.log("cellEditEnding");
        // this.flexSheetIntro.scrollIntoView(80,-1);
        //let rc = this.flexSheetIntro.getCellBoundingRect(100, 0, true);
        if (this.flag) {
            // var rc =  this.flexSheetIntro.cells.getCellBoundingRect(100, 0, true);
            // this.flexSheetIntro.scrollPosition = new wjcCore.Point(this.flexSheetIntro.scrollPosition.x, -rc.top);
            this.flexSheetIntro.scrollIntoView(this.flexSheetIntro.selection.row, -1);
            this.flag = false;
        }
        //this.flexSheetIntro.scrollPosition = new wjcCore.Point(this.flexSheetIntro.scrollPosition.x, -rc.top);
    };
    // initialize the dataMap for the bound sheet.
    AppComponent.prototype._initDataMapForBindingSheet = function (flexSheet) {
        if (flexSheet) {
            var column1 = flexSheet.columns.getColumn('countryId');
            if (column1 && !column1.dataMap) {
                column1.dataMap = this._buildDataMap(this.dataSvc.countries);
            }
            var column2 = flexSheet.columns.getColumn('productId');
            if (column2 && !column2.dataMap) {
                column2.dataMap = this._buildDataMap(this.dataSvc.products);
            }
        }
    };
    // build a data map from a string array using the indices as keys
    AppComponent.prototype._buildDataMap = function (items) {
        var map = [];
        for (var i = 0; i < items.length; i++) {
            map.push({ key: i, value: items[i] });
        }
        return new wjcGrid.DataMap(map, 'key', 'value');
    };
    __decorate([
        core_1.ViewChild('flexSheetIntro'),
        __metadata("design:type", wjcGridSheet.FlexSheet)
    ], AppComponent.prototype, "flexSheetIntro", void 0);
    AppComponent = __decorate([
        core_1.Component({
            selector: 'my-app',
            templateUrl: './app.component.html'
        }),
        __param(0, core_1.Inject(data_service_1.DataSvc)),
        __metadata("design:paramtypes", [data_service_1.DataSvc])
    ], AppComponent);
    return AppComponent;
}());
exports.AppComponent = AppComponent;
//# sourceMappingURL=app.component.js.map