// Angular
import * as wjcGridSheet from 'wijmo/wijmo.grid.sheet';
import * as wjcInput from 'wijmo/wijmo.input';
import * as wjcGrid from 'wijmo/wijmo.grid';
import * as wjcCore from 'wijmo/wijmo';
import * as wjInput from "wijmo/wijmo.input";
import { Component, EventEmitter, Inject, enableProdMode, ViewChild, NgModule } from '@angular/core';
import { FormsModule } from '@angular/forms';
import { CommonModule } from '@angular/common';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { BrowserModule } from '@angular/platform-browser';
import { WjGridSheetModule } from 'wijmo/wijmo.angular2.grid.sheet';
import { WjInputModule } from 'wijmo/wijmo.angular2.input';
import { DataSvc } from './data.service';
import 'rxjs/add/operator/finally';
import * as wjcGridXlsx from 'wijmo/wijmo.grid.xlsx';

'use strict';

// The Explorer application root component.
@Component({
    selector: 'my-app',
    templateUrl: './app.component.html'
})
export class AppComponent {
    protected dataSvc: DataSvc;
    data: any[];
    dataSource: wjcCore.CollectionView;
    flag: boolean;

    // references FlexSheet named 'flexSheet' in the view
    @ViewChild('flexSheetIntro') flexSheetIntro: wjcGridSheet.FlexSheet;
    public gridHeight: number = 50;

    constructor( @Inject(DataSvc) dataSvc: DataSvc) {
        this.dataSvc = dataSvc;
        dataSvc.getData(10)
            .finally(() => console.log("Finally"))
            .subscribe(d =>
                this.data = d
            );
    }

    // flexSheetInit(flexSheetIntro: wjcGridSheet.FlexSheet) {
    //     var self = this;

    //     this.dataSource = new wjcCore.CollectionView(this.data);
    //     if (flexSheetIntro) {
    //         flexSheetIntro.deferUpdate(() => {
    //             flexSheetIntro.selectedSheetIndex = 0;
    //             flexSheetIntro.selectedSheet.itemsSource = this.dataSource;
    //             self._initDataMapForBindingSheet(flexSheetIntro);
    //         });
    //     }
    // }

    flexSheetInit(flexSheetIntro: wjcGridSheet.FlexSheet) {
        var self = this;
        flexSheetIntro.deferUpdate(() => {

            this.dataSource = new wjcCore.CollectionView(this.data);
            this.dataSource.trackChanges = true;
            let grid = new wjcGrid.FlexGrid(document.createElement('div'), {
                itemsSource: this.dataSource,
                columns: [
                    { header: 'Id', binding: 'id', isReadOnly: false, width: 90, visible: true },
                    {
                        header: 'Country Id', binding: 'countryId', width: 100,
                        visible: true, align: 'right', dropDownCssClass: 'data-map-font'
                    },
                    {
                        header: 'Product Id', binding: 'productId', width: 65, isReadOnly: true,
                        visible: true, dataType: 'Number', align: 'right'
                    },
                    { header: 'Date', binding: 'date', isReadOnly: true, width: 65, visible: true, align: 'right' },
                    {
                        header: 'Amount', binding: 'amount', width: 30, isReadOnly: true,
                        visible: true, dataType: 'Boolean'
                    },
                    {
                        header: 'Active', binding: 'active', width: 65, isReadOnly: true,
                        visible: true
                    }
                ]
            });
            flexSheetIntro.addBoundSheet('Assessment', this.dataSource, 0, grid);
            // flexSheetIntro.isTabHolderVisible = false;
            // flexSheetIntro.headersVisibility = wjcGrid.HeadersVisibility.None;
            // flexSheetIntro.selectionMode = wjcGrid.SelectionMode.CellRange;
            // flexSheetIntro.allowDragging = wjcGrid.AllowDragging.None;
            // flexSheetIntro.allowResizing = wjcGrid.AllowResizing.None;
            // this.flexSheetIntro.allowDelete = true;

            // var current = this.dataSource.currentItem ? JSON.stringify(this.dataSource.currentItem) : null;
            // this.dataSource.currentChanged.addHandler(function (s, e) {
            //     current = s.currentItem ? JSON.stringify(s.currentItem) : null;
            //     console.log("currentChanged: " + current);
            //   });

            // let self = this;
            // this.dataSource.itemsEdited.collectionChanged.addHandler(function (s, e) {
            //     console.log("collectionChanged: "+ self.dataSource.itemsEdited);
            // });


            self._initDataMapForBindingSheet(self.flexSheetIntro);

            // let column = self.flexSheetIntro.columns.getColumn('countryId');
            // if (column) {
            //     let columnGrid = column.grid;
            //     columnGrid.formatItem.addHandler((s, e:wjcGrid.FormatItemEventArgs)=> {
            //         var editRange = grid.editRange,
            //             column = e.panel.columns[e.col];

            //         e.cell.innerHTML = "";
            //         // add custom editor
            //         var editorRoot = document.createElement('div');
            //         var input;
            //         if (column.dataType === wjcCore.DataType.String) {
            //             input = new wjInput.ComboBox(editorRoot);
            //             input.itemsSource = this.dataSvc.countries;   
            //             input.displayMemberPath = "country";
            //             input.selectedValuePath = "id";               
            //             input.headerPath = "value";
            //         }               
            //         e.cell.appendChild(editorRoot);                
            //     });
            // }
        });

    }

    public ExportExcel(): void {
        wjcGridXlsx.FlexGridXlsxConverter.save(this.flexSheetIntro, { includeColumnHeaders: true, includeCellStyles: true }, "FlexGrid.xlsx");

    }
    public onRowEditEnded(e: any): void {
        console.log("onRowEditEnded");
    }

    public rowEditStarted(e: any): void {
        console.log("rowEditStarted");
    }

    public selectionChanged(e: any): void {
        // console.log("selectionChanged");
    }


    public loadedRows(s: any, e: any) {
        let height = 0;
        for (let i = 0; i < s.rows.length; i++) {
            height += s.rows[i].renderHeight;
        }
        // add tabholder height
        height += 20;
        s.hostElement.style.height = height + 'px';
    }

    public cellEditEnding(event: any): void {
        console.log("cellEditEnding");
        // this.flexSheetIntro.scrollIntoView(80,-1);
        // let rc = this.flexSheetIntro.getCellBoundingRect(100, 0, true);
        // this.flexSheetIntro.scrollPosition = new wjcCore.Point(this.flexSheetIntro.scrollPosition.x, -rc.top);
        this.flag = true;
    }

    public updatedView(e: any): void {
        console.log("cellEditEnding");
        // this.flexSheetIntro.scrollIntoView(80,-1);
        //let rc = this.flexSheetIntro.getCellBoundingRect(100, 0, true);
        if (this.flag) {
            // var rc =  this.flexSheetIntro.cells.getCellBoundingRect(100, 0, true);
            // this.flexSheetIntro.scrollPosition = new wjcCore.Point(this.flexSheetIntro.scrollPosition.x, -rc.top);
            this.flexSheetIntro.scrollIntoView(this.flexSheetIntro.selection.row, -1);
            this.flag = false;
        }
        //this.flexSheetIntro.scrollPosition = new wjcCore.Point(this.flexSheetIntro.scrollPosition.x, -rc.top);
    }

    // initialize the dataMap for the bound sheet.
    private _initDataMapForBindingSheet(flexSheet: any) {
        if (flexSheet) {
            let column1 = flexSheet.columns.getColumn('countryId');
            if (column1 && !column1.dataMap) {
                column1.dataMap = this._buildDataMap(this.dataSvc.countries);
            }
            let column2 = flexSheet.columns.getColumn('productId');
            if (column2 && !column2.dataMap) {
                column2.dataMap = this._buildDataMap(this.dataSvc.products);
            }
        }
    }

    // build a data map from a string array using the indices as keys
    private _buildDataMap(items: any) {
        var map = [];
        for (var i = 0; i < items.length; i++) {
            map.push({ key: i, value: items[i] });
        }
        return new wjcGrid.DataMap(map, 'key', 'value');
    }
}